# Class AbstractLibrary

java.lang.Object
org.gradle.plugins.ide.eclipse.model.AbstractClasspathEntry
org.gradle.plugins.ide.eclipse.model.AbstractLibrary

All Implemented Interfaces:
  `ClasspathEntry`

Direct Known Subclasses:
  `Library, Variable`

public abstract class AbstractLibrary extends AbstractClasspathEntry
Common superclass for the library elements.

Since:
  1.0

- ## Field Summary

  ### Fields inherited from class AbstractClasspathEntry

  `accessRules, COMPONENT_DEPENDENCY_ATTRIBUTE, COMPONENT_NON_DEPENDENCY_ATTRIBUTE, entryAttributes, exported, path`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `AbstractLibrary(Node node, org.gradle.plugins.ide.eclipse.model.internal.FileReferenceFactory fileReferenceFactory)`
  Creates a new `AbstractLibrary`.
  `AbstractLibrary(FileReference library)`
  Creates a new `AbstractLibrary`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `appendNode(Node node)`
  Append node.
  `boolean`
  `equals(Object o)`
  `FileReference`
  `getJavadocPath()`
  Returns the javadoc path.
  `FileReference`
  `getLibrary()`
  Returns the library.
  `@Nullable ModuleVersionIdentifier`
  `getModuleVersion()`
  Returns the module version.
  `FileReference`
  `getSourcePath()`
  Returns the source path.
  `int`
  `hashCode()`
  `void`
  `setJavadocPath(FileReference path)`
  Sets the javadoc path.
  `void`
  `setLibrary(FileReference library)`
  Sets the library.
  `void`
  `setModuleVersion(@Nullable ModuleVersionIdentifier moduleVersion)`
  Sets the module version.
  `void`
  `setSourcePath(FileReference sourcePath)`
  Sets the source path.
  `String`
  `toString()`

  ### Methods inherited from class AbstractClasspathEntry

  `addClasspathEntry, getAccessRules, getEntryAttributes, getNativeLibraryLocation, getPath, isExported, normalizePath, setAccessRules, setExported, setNativeLibraryLocation, setPath, writeEntryAttributes`

  ### Methods inherited from class Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface ClasspathEntry

  `getKind`

- ## Constructor Details

  - ### AbstractLibrary

    public AbstractLibrary(Node node, org.gradle.plugins.ide.eclipse.model.internal.FileReferenceFactory fileReferenceFactory)
    Creates a new `AbstractLibrary`.
    Since:
      1.0

  - ### AbstractLibrary

    public AbstractLibrary(FileReference library)
    Creates a new `AbstractLibrary`.
    Since:
      1.0

- ## Method Details

  - ### getSourcePath

    public FileReference getSourcePath()
    Returns the source path.
    Since:
      1.0

  - ### setSourcePath

    public void setSourcePath(FileReference sourcePath)
    Sets the source path.
    Since:
      1.0

  - ### getJavadocPath

    public FileReference getJavadocPath()
    Returns the javadoc path.
    Since:
      1.0

  - ### setJavadocPath

    public void setJavadocPath(FileReference path)
    Sets the javadoc path.
    Since:
      1.0

  - ### getLibrary

    public FileReference getLibrary()
    Returns the library.
    Since:
      1.0

  - ### setLibrary

    public void setLibrary(FileReference library)
    Sets the library.
    Since:
      1.0

  - ### getModuleVersion

    public @Nullable ModuleVersionIdentifier getModuleVersion()
    Returns the module version.
    Since:
      1.1

  - ### setModuleVersion

    public void setModuleVersion(@Nullable ModuleVersionIdentifier moduleVersion)
    Sets the module version.
    Since:
      1.1

  - ### appendNode

    public void appendNode(Node node)
    Description copied from interface: `ClasspathEntry`
    Append node.
    Specified by:
      `appendNode` in interface `ClasspathEntry`
    Overrides:
      `appendNode` in class `AbstractClasspathEntry`

  - ### equals

    public boolean equals(Object o)
    Overrides:
      `equals` in class `AbstractClasspathEntry`

  - ### hashCode

    public int hashCode()
    Overrides:
      `hashCode` in class `AbstractClasspathEntry`

  - ### toString

    public String toString()
    Overrides:
      `toString` in class `AbstractClasspathEntry`